{
    "class": "Workflow",
    "hints": [
        {
            "class": "ResourceRequirement",
            "coresMax": 1,
            "ramMax": 2000
        }
    ],
    "inputs": [
        {
            "doc": ".fasta.gz",
            "type": [
                "null",
                "File"
            ],
            "id": "#main/Cdr3QueryFasta"
        },
        {
            "type": {
                "type": "enum",
                "symbols": [
                    "#main/vdjType/Ig",
                    "#main/vdjType/TCR"
                ]
            },
            "id": "#main/vdjType"
        },
        {
            "type": [
                "null",
                {
                    "type": "enum",
                    "symbols": [
                        "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                        "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                        "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                        "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                        "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                        "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                    ]
                }
            ],
            "id": "#main/vdjVersion"
        }
    ],
    "steps": [
        {
            "id": "#main/CallCdr3",
            "run": {
                "id": "#main/CallCdr3/CallCdr3Inner",
                "cwlVersion": "v1.0",
                "class": "CommandLineTool",
                "requirements": [
                    {
                        "dockerPull": "bdgenomics/rhapsody:1.9-beta",
                        "class": "DockerRequirement"
                    },
                    {
                        "class": "InlineJavascriptRequirement"
                    },
                    {
                        "class": "ShellCommandRequirement"
                    }
                ],
                "baseCommand": [
                    "mist_pyirWrapper.py"
                ],
                "inputs": [
                    {
                        "type": [
                            "null",
                            "File"
                        ],
                        "id": "#main/CallCdr3/CallCdr3Inner/Cdr3QueryFasta"
                    },
                    {
                        "type": {
                            "type": "enum",
                            "symbols": [
                                "#main/CallCdr3/CallCdr3Inner/vdjType/Ig",
                                "#main/CallCdr3/CallCdr3Inner/vdjType/TCR"
                            ]
                        },
                        "id": "#main/CallCdr3/CallCdr3Inner/vdjType"
                    },
                    {
                        "type": [
                            "null",
                            {
                                "type": "enum",
                                "symbols": [
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                                ]
                            }
                        ],
                        "id": "#main/CallCdr3/CallCdr3Inner/vdjVersion"
                    }
                ],
                "arguments": [
                    {
                        "prefix": "-r",
                        "valueFrom": "$(inputs.vdjType)"
                    },
                    {
                        "prefix": "--database",
                        "valueFrom": "/mist/pyir_data"
                    },
                    {
                        "prefix": "-f",
                        "valueFrom": "json"
                    },
                    {
                        "prefix": "-m",
                        "valueFrom": "1"
                    },
                    {
                        "prefix": "-s",
                        "valueFrom": "${\n  if (!inputs.vdjVersion) {\n    return(\"~/deliberatelyNotADirectoryToInduceFailure\");\n  } else if (inputs.vdjVersion === \"human\" || inputs.vdjVersion === \"humanBCR\" || inputs.vdjVersion === \"humanTCR\"){\n    return(\"human\");\n  } else if (inputs.vdjVersion === \"mouse\" || inputs.vdjVersion === \"mouseBCR\" || inputs.vdjVersion === \"mouseTCR\"){\n    return(\"mouse\");\n  } else {\n    throw(\"Unknown VDJ version\");\n  }\n}"
                    },
                    {
                        "prefix": "-o",
                        "valueFrom": "${\n  if(inputs.Cdr3QueryFasta){\n    return(inputs.Cdr3QueryFasta.nameroot.split(\".\")[0]);\n  } else {\n    return(\"NA\");\n  }\n}"
                    },
                    {
                        "prefix": "-winput",
                        "valueFrom": "${\n  if (!inputs.vdjType) {\n    return(\"~/deliberatelyNotAQueryFastaToInduceFailure.fasta\");\n  } else {\n    return(inputs.Cdr3QueryFasta);\n  }\n}"
                    },
                    {
                        "valueFrom": "${\n  if (!inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'Since this is not a VDJ run, we will skip this node...'\");\n  } else if (!inputs.vdjVersion && inputs.Cdr3QueryFasta){\n    throw(\"VDJ disabled but CDR3 calling FASTA specified!\");\n  } else if (inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'VDJ enabled, but no query sequence specified. Assuming none were capture in AnnotateReads!'\");\n  } else if (inputs.vdjVersion && inputs.Cdr3QueryFasta) {\n    return(\"\");\n  }\n}",
                        "shellQuote": false
                    }
                ],
                "outputs": [
                    {
                        "type": [
                            "null",
                            "File"
                        ],
                        "outputBinding": {
                            "glob": "*.json.gz",
                            "outputEval": "${\n  if (inputs.vdjVersion && inputs.Cdr3QueryFasta && self.size == 0) {\n    throw(\"No outputs from PyIR detected!\");\n  } else {\n    return(self);\n  }\n}"
                        },
                        "id": "#main/CallCdr3/CallCdr3Inner/Cdr3Call"
                    }
                ]
            },
            "in": [
                {
                    "source": "#main/CallConstantRegion/ConstantRegionCall",
                    "id": "#main/CallCdr3/Cdr3QueryFasta"
                },
                {
                    "source": "#main/vdjType",
                    "id": "#main/CallCdr3/vdjType"
                },
                {
                    "source": "#main/vdjVersion",
                    "id": "#main/CallCdr3/vdjVersion"
                }
            ],
            "out": [
                "#main/CallCdr3/Cdr3Call"
            ]
        },
        {
            "id": "#main/CallConstantRegion",
            "run": {
                "id": "#main/CallConstantRegion/CallConstantRegionInner",
                "cwlVersion": "v1.0",
                "class": "CommandLineTool",
                "requirements": [
                    {
                        "dockerPull": "bdgenomics/rhapsody:1.9-beta",
                        "class": "DockerRequirement"
                    },
                    {
                        "class": "InlineJavascriptRequirement"
                    },
                    {
                        "class": "ShellCommandRequirement"
                    }
                ],
                "baseCommand": [
                    "bowtie2"
                ],
                "inputs": [
                    {
                        "type": [
                            "null",
                            "File"
                        ],
                        "id": "#main/CallConstantRegion/CallConstantRegionInner/Cdr3QueryFasta"
                    },
                    {
                        "type": [
                            "null",
                            {
                                "type": "enum",
                                "symbols": [
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                                    "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                                ]
                            }
                        ],
                        "id": "#main/CallConstantRegion/CallConstantRegionInner/vdjVersion"
                    }
                ],
                "arguments": [
                    "--quiet",
                    "--no-head",
                    "--local",
                    "-p",
                    "1",
                    "-L",
                    "10",
                    "-N",
                    "1",
                    "--ma",
                    "4",
                    {
                        "prefix": "-f",
                        "valueFrom": "$(inputs.Cdr3QueryFasta)"
                    },
                    {
                        "prefix": "-x",
                        "valueFrom": "${\n  if (!inputs.vdjVersion) {\n    return(\"~/deliberatelyNotADirectoryToInduceFailure\");\n  } else if (inputs.vdjVersion === \"human\" || inputs.vdjVersion === \"humanBCR\" || inputs.vdjVersion === \"humanTCR\"){\n    return(\"/mist/vdj_constant_region_reference_index/humanVDJCidx\");\n  } else if (inputs.vdjVersion === \"mouse\" || inputs.vdjVersion === \"mouseBCR\" || inputs.vdjVersion === \"mouseTCR\"){\n    return(\"/mist/vdj_constant_region_reference_index/mouseVDJCidx\");\n  } else {\n    throw(\"Unknown VDJ version\");\n  }\n}"
                    },
                    {
                        "valueFrom": "|",
                        "shellQuote": false
                    },
                    "awk",
                    {
                        "shellQuote": false,
                        "valueFrom": "${\n  if(inputs.Cdr3QueryFasta) {\n    return(\"\\'{print \\\">\\\" $1 \\\",\\\" $3 \\\"\\\\n\\\" $10 |  \\\" gzip >> \" + inputs.Cdr3QueryFasta.nameroot.split(\".\")[0] + \"_constant_region_called.fasta.gz\\\"}\\'\");\n  } else {\n    return(\"\\'{print \\\">\\\" $1 \\\",\\\" $3 \\\"\\\\n\\\" $10}\\'\");\n  }\n}"
                    },
                    {
                        "valueFrom": "${\n  if (!inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'Since this is not a VDJ run, we will skip this node...'\");\n  } else if (!inputs.vdjVersion && inputs.Cdr3QueryFasta){\n    throw(\"VDJ disabled but CDR3 calling FASTA specified!\");\n  } else if (inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'VDJ enabled, but no query sequence specified. Assuming none were capture in AnnotateReads!'\");\n  } else if (inputs.vdjVersion && inputs.Cdr3QueryFasta) {\n    return(\"\");\n  }\n}",
                        "shellQuote": false
                    }
                ],
                "outputs": [
                    {
                        "type": [
                            "null",
                            "File"
                        ],
                        "outputBinding": {
                            "glob": "*_constant_region_called.fasta.gz",
                            "outputEval": "${\n  if (!inputs.vdjVersion) {\n    return(null);\n  } else {\n    return(self);\n  }\n}"
                        },
                        "id": "#main/CallConstantRegion/CallConstantRegionInner/ConstantRegionCall"
                    }
                ]
            },
            "in": [
                {
                    "source": "#main/Cdr3QueryFasta",
                    "id": "#main/CallConstantRegion/Cdr3QueryFasta"
                },
                {
                    "source": "#main/vdjVersion",
                    "id": "#main/CallConstantRegion/vdjVersion"
                }
            ],
            "out": [
                "#main/CallConstantRegion/ConstantRegionCall"
            ]
        },
        {
            "run": {
                "id": "#main/PrunePyIR/PrunePyIRInner",
                "cwlVersion": "v1.0",
                "class": "CommandLineTool",
                "requirements": [
                    {
                        "dockerPull": "bdgenomics/rhapsody:1.9-beta",
                        "class": "DockerRequirement"
                    }
                ],
                "baseCommand": [
                    "mist_prune_pyir.py"
                ],
                "inputs": [
                    {
                        "type": [
                            "null",
                            "File"
                        ],
                        "inputBinding": {
                            "position": 0
                        },
                        "id": "#main/PrunePyIR/PrunePyIRInner/PyIROutput"
                    }
                ],
                "outputs": [
                    {
                        "type": [
                            "null",
                            "File"
                        ],
                        "outputBinding": {
                            "glob": "*_pruned.csv.gz"
                        },
                        "id": "#main/PrunePyIR/PrunePyIRInner/PrunedPyIROutput"
                    }
                ]
            },
            "in": [
                {
                    "source": "#main/CallCdr3/Cdr3Call",
                    "id": "#main/PrunePyIR/PyIROutput"
                }
            ],
            "out": [
                "#main/PrunePyIR/PrunedPyIROutput"
            ],
            "id": "#main/PrunePyIR"
        }
    ],
    "id": "#main",
    "outputs": [
        {
            "type": [
                "null",
                "File"
            ],
            "outputSource": "#main/PrunePyIR/PrunedPyIROutput",
            "id": "#main/Cdr3Call"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://sevenbridges.com#",
        "arv": "http://arvados.org/cwl#"
    }
}
